/*
                 Blow Controller using joystick
                 Created 24 Apr 2021
                 by Selena Pere
                 */

                 int VRx = A2;
                 int VRy = A3;
                 int SW = A4;

                 int xPos = 0;
                 int yPos = 0;
                 int swState = 0;
                 int mapX = 0;
                 int mapY = 0;

                 int DOWN = 5;
                 int UP = 6;
                 int RIGHT = 7;
                 int LEFT = 8;

                 int blowSensor = A1;

                 int barLED1 = 2;
                 int barLED2 = 3;
                 int barLED3 = 4;
                 int barButton = A0;



                 void setup() {
                   Serial.begin(9600);
                   pinMode(VRx, INPUT);
                   pinMode(VRy, INPUT);

                   pinMode(SW, INPUT);
                   digitalWrite(SW, HIGH);

                   pinMode(UP, OUTPUT);
                   pinMode(DOWN, OUTPUT);
                   pinMode(LEFT, OUTPUT);
                   pinMode(RIGHT, OUTPUT);

                   pinMode(barButton, INPUT_PULLUP);

                   pinMode(barLED1, OUTPUT);
                   pinMode(barLED2, OUTPUT);
                   pinMode(barLED3, OUTPUT);

                   pinMode(blowSensor, INPUT);

                   digitalWrite(barLED1, HIGH);
                   digitalWrite(barLED2, HIGH);
                   digitalWrite(barLED3, HIGH);

                   digitalWrite(UP, HIGH);
                   digitalWrite(DOWN, HIGH);
                   digitalWrite(LEFT, HIGH);
                   digitalWrite(RIGHT, HIGH);
                   delay(500);

                   xPos = analogRead(VRx);
                   yPos = analogRead(VRy);
                   swState = analogRead(SW);

                   }



                  void loop() {
                   // read the input of blowSensor pin A1:
                   int blowValue = analogRead(A1);
                   Serial.println(blowValue);
                   delay(1);

                   //Display Bargraph
                   int barButtonState = digitalRead(barButton);
                   if (barButtonState == HIGH){
                         barGraph();
                       }

                   //LED lit when blowed on rc motor
                   if(blowValue > 50){
                     buttonLitLed();

                   }
                   else {
                     turnLedOff();
                     delay(10);
                   }
                  }



                   void barGraph()
                  {

                   // read the input of blowSensor pin A1:
                   int blowValue = analogRead(A1);
                   Serial.println(blowValue);
                   delay(1);

                   if(blowValue < 50){
                     digitalWrite(barLED1, LOW);
                     digitalWrite(barLED2, LOW);
                     digitalWrite(barLED3, LOW);

                   }

                   else if(blowValue >= 50 && blowValue < 100){
                     digitalWrite(barLED1, HIGH);
                     digitalWrite(barLED2, LOW);
                     digitalWrite(barLED3, LOW);

                   }

                   else if(blowValue >= 100 && blowValue < 200){
                     digitalWrite(barLED1, HIGH);
                     digitalWrite(barLED2, HIGH);
                     digitalWrite(barLED3, LOW);

                   }

                   else if(blowValue >= 200 && blowValue < 1023){
                     digitalWrite(barLED1, HIGH);
                     digitalWrite(barLED2, HIGH);
                     digitalWrite(barLED3, HIGH);

                   }
                   delay(500);
                   digitalWrite(barLED1, LOW);
                   digitalWrite(barLED2, LOW);
                   digitalWrite(barLED3, LOW);

                   }



                   void buttonLitLed() {

                     mapX = analogRead(VRx);
                     mapY = analogRead(VRy);
                     swState = digitalRead(SW);

                     if(mapX >= 612)
                     {
                       digitalWrite(UP, HIGH);
                       delay(100);
                     }
                     else
                     {
                       digitalWrite(UP, LOW);
                     }


                     if(mapX <= 412)
                     {
                       digitalWrite(DOWN, HIGH);
                       delay(100);
                     }
                     else
                     {
      digitalWrite(DOWN, LOW);
                     }


                     if(mapY >= 612)
                     {
                       digitalWrite(RIGHT, HIGH);
                       delay(100);
                     }
                     else
                     {
                       digitalWrite(RIGHT, LOW);
                     }


                     if(mapY <= 412)
                     {
                       digitalWrite(LEFT, HIGH);
                       delay(100);
                     }
                     else
                     {
                       digitalWrite(LEFT, LOW);
                     }


                     if(swState == 0)
                     {
                       digitalWrite(UP, HIGH);
                       digitalWrite(DOWN, HIGH);
                       digitalWrite(LEFT, HIGH);
                       digitalWrite(RIGHT, HIGH);
                     }
                     else
                     {
                       digitalWrite(UP, LOW);
                       digitalWrite(DOWN, LOW);
                       digitalWrite(LEFT, LOW);
                       digitalWrite(RIGHT, LOW);
                     }


                     delay(10);

                   }



                   void turnLedOff()
                 {
                   digitalWrite(UP, LOW);
                   digitalWrite(DOWN, LOW);
                   digitalWrite(RIGHT, LOW);
                   digitalWrite(LEFT, LOW);
                 }
